/*
       . 
      ! -
      IBM-   
    486.    
 Celeron 433 Mhz.  
:   . 
: 2002, .

*/

#if !defined(HugeInt_01_H__2F9BCAE4_A1B5_11D6_B9B1_90B34AC10101__INCLUDED_)
#define HugeInt_01_H__2F9BCAE4_A1B5_11D6_B9B1_90B34AC10101__INCLUDED_


const MaxLen = 65;
unsigned int typedef UI;

class HugeInt
{UI len;
 UI number[MaxLen];
 static  HugeInt Modul;

 void    mult1(UI, UI);
 void	 SetLen(UI);
 void	 mult2(const HugeInt&, const HugeInt&, UI);
 void	 div1(UI);
 HugeInt getJN (UI,UI);
 void	 setJN (const HugeInt&,UI,UI);
 void mult11(UI);
 
public: 
 HugeInt() {len=1; number[0]=0;};
 HugeInt(char *);
 HugeInt(const HugeInt& oth) // 
	{for (int i=0; i<oth.len; i++) {number[i]=oth.number[i];};
	 len=oth.len;
	};
 
 HugeInt(UI k) // -   UI
	{len=1; number[0]=k;};

 HugeInt::HugeInt(const int k) // -   int
	{len=1; number[0]=k;};

 HugeInt& operator= (const HugeInt&);

 HugeInt& operator+= (const HugeInt&);
 HugeInt& operator-= (const HugeInt&);
 HugeInt& operator*= (const HugeInt&);
 HugeInt& operator/= (const HugeInt&);
 HugeInt& operator%= (const HugeInt&);
 HugeInt& operator>>= (int);
 HugeInt& operator<<= (int);

 void IntSHL(int);
 void IntSHR(int);
 
 void GetNumber1();
 void PrnNumber1();
 void GetNumber();
 void PrnNumber();
 void RetStr(char*, char);
 void GetStr(char*);


 void Normal();

 inline UI GetDigit(int i)		{return number[i];};
 inline void SetDigit(int i, UI n)	 {number[i]=n;};

 friend bool operator <  (HugeInt,HugeInt);
 friend bool operator >  (HugeInt,HugeInt);
 friend bool operator <= (HugeInt,HugeInt);
 friend bool operator >= (HugeInt,HugeInt);
 friend bool operator == (HugeInt,HugeInt);
 friend bool operator != (HugeInt,HugeInt);
 static HugeInt GetMod();
 inline bool IfError() {return !len;}; 
 bool odd () {return ((number[0]&1)&&len);};
     // ,       0,
	 //    true,  - false.
};

HugeInt operator+ (HugeInt, HugeInt);
HugeInt operator- (HugeInt, HugeInt);
HugeInt operator* (HugeInt, HugeInt);
HugeInt operator/ (HugeInt, HugeInt);
HugeInt operator% (HugeInt, HugeInt);
HugeInt operator<< (HugeInt, int);
HugeInt operator>> (HugeInt, int);

#endif // !defined(HugeInt_01_H__2F9BCAE4_A1B5_11D6_B9B1_90B34AC10101__INCLUDED_)
